#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityLuckyBagCFG.h"
std::auto_ptr<M_ActivityLuckyBagCFG> M_ActivityLuckyBagCFG::msSingleton(nullptr);

int M_ActivityLuckyBagCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityLuckyBagCFGData* M_ActivityLuckyBagCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityLuckyBagCFGData>& M_ActivityLuckyBagCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityLuckyBagCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityLuckyBagCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityLuckyBagCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mCount = element->IntAttribute("Count");
		data.mItemId = element->IntAttribute("ItemId");
		data.mItemNumber = element->IntAttribute("ItemNumber");
		data.mRechangId = element->IntAttribute("RechangId");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityLuckyBagCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityLuckyBagCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityLuckyBagCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityLuckyBagCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityLuckyBagCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Count", data.mCount);
		LuaCfgHelper::readInt(L, "ItemId", data.mItemId);
		LuaCfgHelper::readInt(L, "ItemNumber", data.mItemNumber);
		LuaCfgHelper::readInt(L, "RechangId", data.mRechangId);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityLuckyBagCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityLuckyBagCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityLuckyBagCFG* M_ActivityLuckyBagCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityLuckyBagCFG());
	}
	return msSingleton.get();
}

void M_ActivityLuckyBagCFG::Release()
{
	msSingleton.reset(nullptr);
}
